Index: FL/Fl_Export.H
===================================================================
--- FL/Fl_Export.H	(revision 10206)
+++ FL/Fl_Export.H	(working copy)
@@ -29,6 +29,8 @@
 #    else
 #      define FL_EXPORT	__declspec(dllimport)
 #    endif /* FL_LIBRARY */
+#  elif __GNUC__ >= 4
+#    define FL_EXPORT __attribute__ ((visibility ("default")))
 #  else
 #    define FL_EXPORT
 #  endif /* FL_DLL */
Index: configure.in
===================================================================
--- configure.in	(revision 10206)
+++ configure.in	(working copy)
@@ -1142,7 +1142,8 @@
 
     # Generate position-independent code when needed...
     if test $PICFLAG = 1; then
-    	OPTIM="$OPTIM -fPIC"
+    	OPTIM="$OPTIM -fPIC -fvisibility=hidden"
+    	CXXFLAGS="$CXXFLAGS -fvisibility-inlines-hidden"
     fi
 
     # See if GCC supports -fno-exceptions...
Index: src/Fl_x.cxx
===================================================================
--- src/Fl_x.cxx	(revision 10206)
+++ src/Fl_x.cxx	(working copy)
@@ -36,6 +36,7 @@
 #  include <FL/Fl_Paged_Device.H>
 #  include <FL/Fl_Shared_Image.H>
 #  include <FL/fl_ask.H>
+#  include <FL/filename.H>
 #  include <stdio.h>
 #  include <stdlib.h>
 #  include "flstring.h"
